////////////////////////////////////////////////////////////////////////////
//
//  This file is part of RTIMULib
//
//  Copyright (c) 2014-2015, richards-tech, LLC
//
//  Permission is hereby granted, free of charge, to any person obtaining a copy of
//  this software and associated documentation files (the "Software"), to deal in
//  the Software without restriction, including without limitation the rights to use,
//  copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the
//  Software, and to permit persons to whom the Software is furnished to do so,
//  subject to the following conditions:
//
//  The above copyright notice and this permission notice shall be included in all
//  copies or substantial portions of the Software.
//
//  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
//  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
//  PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
//  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
//  OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
//  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


#include "RTIMULib.h"
#include <string>

int main(int argc, char *argv[])
{
    bool sendGyros = false;
    bool sendAccel = false;
    bool sendCompa = false;
    bool sendQuats = false;
    int opt;
    int update_frequency = 100000; 
     
    while ((opt = getopt (argc, argv, "gacqhf:")) != -1) {
        switch (opt) {
        case 'g':
            sendGyros = true;
            break;
        case 'a':
            sendAccel = true;
            break;
        case 'c':
            sendCompa = true;
            break;
        case 'q':
            sendQuats = true;
            break;
        case 'f':
            if(optarg) update_frequency = atoi(optarg);
            break;
        case 'h':
            printf("g : sends the gyroscopes measurements, 3 values: Roll, Pitch, Yaw\n");
            printf("a : sends the acceleration measurements, 3 values: X, Y, Z\n");
            printf("c : sends the compass measurements, 3 values: Roll, Pitch, Yaw\n");
            printf("q : sends the quaternions fusion, 4 values: W, X, Y, Z\n");
            printf("f : sampling period in micro seconds (requires a value)\n");
            return 1;
            break;
        } 
    }

    int sampleCount = 0;
    int sampleRate = 0;
    uint64_t rateTimer;
    uint64_t displayTimer;
    uint64_t now;

    //  Using RTIMULib here allows it to use the .ini file generated by RTIMULibDemo.
    //  Or, you can create the .ini in some other directory by using:
    //      RTIMUSettings *settings = new RTIMUSettings("<directory path>", "RTIMULib");
    //  where <directory path> is the path to where the .ini file is to be loaded/saved
    RTIMUSettings *settings = new RTIMUSettings("RTIMULib");

    RTIMU *imu = RTIMU::createIMU(settings);

    if ((imu == NULL) || (imu->IMUType() == RTIMU_TYPE_NULL)) {
        printf("No IMU found\n");
        exit(1);
    }

    //  This is an opportunity to manually override any settings before the call IMUInit
    //  set up IMU
    imu->IMUInit();

    //  this is a convenient place to change fusion parameters
    imu->setSlerpPower(0.02);
    imu->setGyroEnable(true);
    imu->setAccelEnable(true);
    imu->setCompassEnable(true);

    //  set up for rate timer
    rateTimer = displayTimer = RTMath::currentUSecsSinceEpoch();

    //  now just process data
    while (1) {
        //  poll at the rate recommended by the IMU
        usleep(imu->IMUGetPollInterval() * 1000);

        while (imu->IMURead()) {
            RTIMU_DATA imuData = imu->getIMUData();
            sampleCount++;

            now = RTMath::currentUSecsSinceEpoch();

            //  display 10 times per second
            if ((now - displayTimer) > update_frequency) {
                std::string QPose(RTMath::displayQRaw(imuData.fusionQPose));
                std::string Acc(RTMath::displayRaw(imuData.accel));
                std::string Gyro(RTMath::displayRaw(imuData.gyro));
                std::string Compass(RTMath::displayRaw(imuData.compass));
                printf("T:%ld\n", now);
                if(sendGyros) printf("G:%s\n", Gyro.c_str());
                if(sendAccel) printf("A:%s\n", Acc.c_str());
                if(sendCompa) printf("C:%s\n", Compass.c_str());
                if(sendQuats) printf("Q:%s\n", QPose.c_str());
                printf("--\n");
                fflush(stdout);
                displayTimer = now;
            }

            //  update rate every second
            if ((now - rateTimer) > 1000000) {
                sampleRate = sampleCount;
                sampleCount = 0;
                rateTimer = now;
            }
        }
    }
}

